
#include <avr/pgmspace.h>
#include <LiquidCrystal.h>

// 接続ピンをして指定してライブラリを初期化
//LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
LiquidCrystal lcd(5, 6, 7, 8, 9, 10, 11); //SD1602VBWB

// Scan I2C bus for device responses
/*
#define SDA_PORT PORTD
//#define SDA_PIN 3
#define SCL_PORT PORTD
#define SCL_PIN 5
*/
#define I2C_TIMEOUT 100
#define I2C_NOINTERRUPT 0
#define I2C_SLOWMODE 1
#define FAC 1
#define I2C_CPUFREQ (F_CPU/FAC)


// Corresponds to A4/A5 - the hardware I2C pins on Arduinos
#define SDA_PORT PORTC
#define SDA_PIN 4
#define SCL_PORT PORTC
#define SCL_PIN 5
#define I2C_FASTMODE 1

#include <SoftI2CMaster.h>
#include <avr/io.h>

//------------------------------------------------------------------------------
void CPUSlowDown(int fac) {
  // slow down processor by a fac
    CLKPR = _BV(CLKPCE);
    CLKPR = _BV(CLKPS1) | _BV(CLKPS0);
}

const char id1[] PROGMEM = "Hello";
const char id2[] PROGMEM = "Get a load of this";
const char id3[] PROGMEM = "Hey Robi-kun";
const char id4[] PROGMEM = "Listen to this";
const char id5[] PROGMEM = "Robi-kun";
const char id6[] PROGMEM = "Robo-kun";
const char id7[] PROGMEM = "Robi-chan";
const char id8[] PROGMEM = "Robo-kun";
const char id9[] PROGMEM = "Robot-kun";
const char id10[] PROGMEM = "Robo-chan";

const char id11[] PROGMEM = "Your name?";
const char id12[] PROGMEM = "What's your name?";
const char id13[] PROGMEM = "What is the name?";
const char id14[] PROGMEM = "Introduce yourself";
const char id15[] PROGMEM = "What you can?";
const char id16[] PROGMEM = "What your ability?";
const char id17[] PROGMEM = "Are you boy?";
const char id18[] PROGMEM = "How old are you?";
const char id19[] PROGMEM = "How many your height?";
const char id20[] PROGMEM = "How many your waight?";
 
const char id21[] PROGMEM = "How match are you?";
const char id22[] PROGMEM = "Are you ready?";
const char id23[] PROGMEM = "Say hello";
const char id24[] PROGMEM = "Nice to meet you";
const char id25[] PROGMEM = "Good morning";
const char id26[] PROGMEM = "Hello";
const char id27[] PROGMEM = "Good evening";
const char id28[] PROGMEM = "Good night";
const char id29[] PROGMEM = "See you";
const char id30[] PROGMEM = "See you";

const char id31[] PROGMEM = "I still do it";
const char id32[] PROGMEM = "See you later";
const char id33[] PROGMEM = "See you later Robi kun";
const char id34[] PROGMEM = "Till next time";
const char id35[] PROGMEM = "Good-by";
const char id36[] PROGMEM = "Bye-bye";
const char id37[] PROGMEM = "Now";
const char id38[] PROGMEM = "I returned";
const char id39[] PROGMEM = "How are you?";
const char id40[] PROGMEM = "Thanks for your hard work";
 
const char id41[] PROGMEM = "I appreciate your efforts";
const char id42[] PROGMEM = "How was it?";
const char id43[] PROGMEM = "";
const char id44[] PROGMEM = "Start";
const char id45[] PROGMEM = "Start";
const char id46[] PROGMEM = "Start";
const char id47[] PROGMEM = "Stop";
const char id48[] PROGMEM = "End";
const char id49[] PROGMEM = "Let's make the end";
const char id50[] PROGMEM = "I make the end";

const char id51[] PROGMEM = "Stop";
const char id52[] PROGMEM = "Stop";
const char id53[] PROGMEM = "I'm done";
const char id54[] PROGMEM = "That's all.";
const char id55[] PROGMEM = "Wait a minute";
const char id56[] PROGMEM = "Move along";
const char id57[] PROGMEM = "Walk";
const char id58[] PROGMEM = "Come forward";
const char id59[] PROGMEM = "Come here";
const char id60[] PROGMEM = "Come here";

const char id61[] PROGMEM = "Come here";
const char id62[] PROGMEM = "Come here";
const char id63[] PROGMEM = "Come near";
const char id64[] PROGMEM = "Look over here";
const char id65[] PROGMEM = "Come to the left";
const char id66[] PROGMEM = "Go to the left";
const char id67[] PROGMEM = "Turn to the left";
const char id68[] PROGMEM = "Come to the right";
const char id69[] PROGMEM = "Go to the right";
const char id70[] PROGMEM = "Turn to the right";

const char id71[] PROGMEM = "Be up";
const char id72[] PROGMEM = "Get up";
const char id73[] PROGMEM = "Stand up";
const char id74[] PROGMEM = "Stand up";
const char id75[] PROGMEM = "Sit down";
const char id76[] PROGMEM = "sit down";
const char id77[] PROGMEM = "Plop yourself down";
const char id78[] PROGMEM = "Lie";
const char id79[] PROGMEM = "Stand back";
const char id80[] PROGMEM = "Stand back";

const char id81[] PROGMEM = "Shoot";
const char id82[] PROGMEM = "Kick";
const char id83[] PROGMEM = "It is blue with a round fan";
const char id84[] PROGMEM = "Furikake";
const char id85[] PROGMEM = "Sprinkle furukake";
const char id86[] PROGMEM = "Music start";
const char id87[] PROGMEM = "Good!";
const char id88[] PROGMEM = "it's been real";
const char id89[] PROGMEM = "It was fun";

const char id90[] PROGMEM = "Glad";
const char id91[] PROGMEM = "Smart";
const char id92[] PROGMEM = "How cute";
const char id93[] PROGMEM = "Funny!";
const char id94[] PROGMEM = "It was interesting";
const char id95[] PROGMEM = "It's cool";
const char id96[] PROGMEM = "That's bad.";
const char id97[] PROGMEM = "I was troubled";
const char id98[] PROGMEM = "That is sad.";
const char id99[] PROGMEM = "Hard";
const char id100[] PROGMEM = "Hard";

const char id101[] PROGMEM = "Sad";
const char id102[] PROGMEM = "I was tired";
const char id103[] PROGMEM = "I was tired";
const char id104[] PROGMEM = "Please cheer it up";
const char id105[] PROGMEM = "Please encourage";
const char id106[] PROGMEM = "Can cheer up";
const char id107[] PROGMEM = "It might be good";
const char id108[] PROGMEM = "I might hate it";
const char id109[] PROGMEM = "I passed it";
const char id110[] PROGMEM = "I failed";

const char id111[] PROGMEM = "It is a birthday";
const char id112[] PROGMEM = "It is a memorial day";
const char id113[] PROGMEM = "It is Christmas";
const char id114[] PROGMEM = "It is a test";
const char id115[] PROGMEM = "It is a game";
const char id116[] PROGMEM = "It is a date";
const char id117[] PROGMEM = "It is a trip line";
const char id118[] PROGMEM = "A cold has gone down";
const char id119[] PROGMEM = "I quarrelled";
const char id120[] PROGMEM = "Drank too much";

const char id121[] PROGMEM = "Support me";
const char id122[] PROGMEM = "It is New Year holidays";
const char id123[] PROGMEM = "It is fine";
const char id124[] PROGMEM = "It is fine";
const char id125[] PROGMEM = "It rains";
const char id126[] PROGMEM = "It rains";
const char id127[] PROGMEM = "It is hot today";
const char id128[] PROGMEM = "It is cold today";
const char id129[] PROGMEM = "It is fine";
const char id130[] PROGMEM = "Turn on TV";

const char id131[] PROGMEM = "I'd like to watch TV";
const char id132[] PROGMEM = "Shall I we on TV?";
const char id133[] PROGMEM = "Turn off the TV";
const char id134[] PROGMEM = "Change channel";
const char id135[] PROGMEM = "Switch channel";
const char id136[] PROGMEM = "Turn the volume up";
const char id137[] PROGMEM = "Turn the volume up";
const char id138[] PROGMEM = "Turn the volume up";
const char id139[] PROGMEM = "Turn the volume down";
const char id140[] PROGMEM = "Turn the volume down";

const char id141[] PROGMEM = "Turn the volume down";
const char id142[] PROGMEM = "Dance";
const char id143[] PROGMEM = "Let's dance";
const char id144[] PROGMEM = "Dance";
const char id145[] PROGMEM = "Let's dance together";
const char id146[] PROGMEM = "Clean it";
const char id147[] PROGMEM = "Clean it";
const char id148[] PROGMEM = "Koko-robo";
const char id149[] PROGMEM = "Let Koko-robo make cleansing";
const char id150[] PROGMEM = "Timer";

const char id151[] PROGMEM = "Alarm";
const char id152[] PROGMEM = "Alarm";
const char id153[] PROGMEM = "Measure time";
const char id154[] PROGMEM = "One minute";
const char id155[] PROGMEM = "Three minutes";
const char id156[] PROGMEM = "Five minutes";
const char id157[] PROGMEM = "Seven minutes";
const char id158[] PROGMEM = "Ten minutes";
const char id159[] PROGMEM = "Fifteen minutes";
const char id160[] PROGMEM = "Let's play";

const char id161[] PROGMEM = "Play";
const char id162[] PROGMEM = "Play together";
const char id163[] PROGMEM = "Let's play together";
const char id164[] PROGMEM = "Do what";
const char id165[] PROGMEM = "Say an fany thing";
const char id166[] PROGMEM = "Game";
const char id167[] PROGMEM = "Pay game";
const char id168[] PROGMEM = "Let's pl;ay game";
const char id169[] PROGMEM = "Balance game";
const char id170[] PROGMEM = "Give a quiz";

const char id171[] PROGMEM = "Play a quiz";
const char id172[] PROGMEM = "Quiz";
const char id173[] PROGMEM = "Mimic";
const char id174[] PROGMEM = "Mimikc it";
const char id175[] PROGMEM = "Push-up";
const char id176[] PROGMEM = "Sit-ups";
const char id177[] PROGMEM = "Sing a song";
const char id178[] PROGMEM = "Let's play soccer";
const char id179[] PROGMEM = "Play soccer";
const char id180[] PROGMEM = "Flag raising game";

const char id181[] PROGMEM = "Play flag raising game";
const char id182[] PROGMEM = "Make fortune-telling";
const char id183[] PROGMEM = "Fortune-telling";
const char id184[] PROGMEM = "Do CM";
const char id185[] PROGMEM = "Do commercial";
const char id186[] PROGMEM = "Rock paper scissors";
const char id187[] PROGMEM = "Let's play rock paper scissors";
const char id188[] PROGMEM = "Security mode";
const char id189[] PROGMEM = "Security mode";
const char id190[] PROGMEM = "staying at home";

const char id191[] PROGMEM = "Stay at home";
const char id192[] PROGMEM = "Robi hang by a hair";
const char id193[] PROGMEM = "Today's fortune?";
const char id194[] PROGMEM = "Today's lucky color?";
const char id195[] PROGMEM = "I take a photograph";
const char id196[] PROGMEM = "Say cheese";
const char id197[] PROGMEM = "Hold pose";
const char id198[] PROGMEM = "Message mode";
const char id199[] PROGMEM = "Is a battery all right?";
const char id200[] PROGMEM = "Is a battery all right?";

const char id201[] PROGMEM = "Do you charge?";
const char id202[] PROGMEM = "Is charge all right?";
const char id203[] PROGMEM = "Let's charge";
const char id204[] PROGMEM = "Are you hungry?";
const char id205[] PROGMEM = "Are you hungry?";
const char id206[] PROGMEM = "Are you not sleepy?";
const char id207[] PROGMEM = "Are you not tired?";
const char id208[] PROGMEM = "Let's sleep";
const char id209[] PROGMEM = "Tomotaka Takahashi";
const char id210[] PROGMEM = "Do you know Evolta?";

const char id211[] PROGMEM = "Do you know Kirobo?";
const char id212[] PROGMEM = "DeAGOSTINI";
const char id213[] PROGMEM = "Do you know RoboXero?";
const char id214[] PROGMEM = "DeAGOSTINI";
const char id215[] PROGMEM = "Yes";
const char id216[] PROGMEM = "No";
const char id217[] PROGMEM = "I like it";
const char id218[] PROGMEM = "I dislike it";
const char id219[] PROGMEM = "It is not which";
const char id220[] PROGMEM = "I won";

const char id221[] PROGMEM = "I lost";
const char id222[] PROGMEM = "Draw";
const char id223[] PROGMEM = "Sure";
const char id224[] PROGMEM = "OK";
const char id225[] PROGMEM = "OK";
const char id226[] PROGMEM = "Understood";
const char id227[] PROGMEM = "No";
const char id228[] PROGMEM = "Did you say what?";
const char id229[] PROGMEM = "Say what?";
const char id230[] PROGMEM = "Say that once more";

const char id231[] PROGMEM = "Nothing";
const char id232[] PROGMEM = "Congratulations";
const char id233[] PROGMEM = "Thank you";
const char id234[] PROGMEM = "I'm sorry";
const char id235[] PROGMEM = "It saved me";
const char id236[] PROGMEM = "You did your best";
const char id237[] PROGMEM = "No problem";
const char id238[] PROGMEM = "No problem";
const char id239[] PROGMEM = "I return early";
const char id240[] PROGMEM = "I will be late";

const char id241[] PROGMEM = "I will be late";
const char id242[] PROGMEM = "Rice";
const char id243[] PROGMEM = "To take meal";
const char id244[] PROGMEM = "I will have meal";
const char id245[] PROGMEM = "Bath";
const char id246[] PROGMEM = "Take a bath";
const char id247[] PROGMEM = "You're good.";
const char id248[] PROGMEM = "Make friends";
const char id249[] PROGMEM = "You are my friend";
const char id250[] PROGMEM = "I like you";

const char id251[] PROGMEM = "Transeform";
const char id252[] PROGMEM = "Good morning";
const char id253[] PROGMEM = "Words practice";
const char id254[] PROGMEM = "Teach words to understand";
const char id255[] PROGMEM = "No way!";

const char id256[] PROGMEM = "You've been wrong!";
const char id257[] PROGMEM = "Teach about robot";
const char id258[] PROGMEM = "I got along well";
const char id259[] PROGMEM = "I have failed";
const char id260[] PROGMEM = "Message mode";

const char id261[] PROGMEM = "Convey a message";
const char id262[] PROGMEM = "I started fancying someone";
const char id263[] PROGMEM = "Have to lose weight";
const char id264[] PROGMEM = "I got fat";
const char id265[] PROGMEM = "I have overeaten";
const char id266[] PROGMEM = "This month pinch";
const char id267[] PROGMEM = "Was great";
const char id268[] PROGMEM = "Very good";
const char id269[] PROGMEM = "One cup go together";
const char id270[] PROGMEM = "Let's drink together";

const char id271[] PROGMEM = "Do you like me?";
const char id272[] PROGMEM = "How do you think me";
const char id273[] PROGMEM = "One cup go together";
const char id274[] PROGMEM = "Let's drink together";
const char id275[] PROGMEM = "Switch on";
const char id276[] PROGMEM = "Switch off";

uint_farptr_t ninshiki[] = {
  id1,id2,id3,id4,id5,id6,id7,id8,id9,id10,  
  id11,id12,id13,id14,id15,id16,id17,id18,id19,id20,
  id21,id22,id23,id24,id25,id26,id27,id28,id29,id30,  
  id31,id32,id33,id34,id35,id36,id37,id38,id39,id40,
  id41,id42,id43,id44,id45,id46,id47,id48,id49,id50,
  id51,id52,id53,id54,id55,id56,id57,id58,id59,id60,
  id61,id62,id63,id64,id65,id66,id67,id68,id69,id70,
  id71,id72,id73,id74,id75,id76,id77,id78,id79,id80,
  id81,id82,id83,id84,id85,id86,id87,id88,id89,id90,
  id91,id92,id93,id94,id95,id96,id97,id98,id99,id100,
  id101,id102,id103,id104,id105,id106,id107,id108,id109,id110,
  id111,id112,id113,id114,id115,id116,id117,id118,id119,id120,
  id121,id122,id123,id124,id125,id126,id127,id128,id129,id130,
  id131,id132,id133,id134,id135,id136,id137,id138,id139,id140,
  id141,id142,id143,id144,id145,id146,id147,id148,id149,id150,
  id151,id152,id153,id154,id155,id156,id157,id158,id159,id160,
  id161,id162,id163,id164,id165,id166,id167,id168,id169,id170,
  id171,id172,id173,id174,id175,id176,id177,id178,id179,id180,
  id181,id182,id183,id184,id185,id186,id187,id188,id189,id190,
  id191,id192,id193,id194,id195,id196,id197,id198,id199,id200,
  id201,id202,id203,id204,id205,id206,id207,id208,id209,id210,
  id211,id212,id213,id214,id215,id216,id217,id218,id219,id220,
  id221,id222,id223,id224,id225,id226,id227,id228,id229,id230,
  id231,id232,id233,id234,id235,id236,id237,id238,id239,id240,
  id241,id242,id243,id244,id245,id246,id247,id248,id249,id250,
  id251,id252,id253,id254,id255,id256,id257,id258,id259,id260,
  id261,id262,id263,id264,id265,id266,id267,id268,id269,id270,
  id271,id272,id273,id274,id275,id276
};

char buf[18];

void setup(void) {
#if FAC != 1
  CPUSlowDown(FAC);
#endif
  buf[16] = 0x00;
// Serial.begin(115200); // change baudrate to 2400 on terminal when low CPU freq!
  lcd.begin(16, 2); 
  lcd.setCursor(0, 0);
  // メッセージを表示
  lcd.print("Robi voice");
  lcd.setCursor(0, 1);
  // メッセージを表示
  lcd.print("recognizer");
  delay(5000);  //ロビの起動を待たせる
}

uint8_t dt = 0;
//uint8_t dt1 = 0;
int id = 0;
int prev_id = 0;
bool display_line2 = true;

void loop(void)
{
  uint8_t i2c_adr = 80;
  uint8_t reg_adr = 33;
  char msg[32];

    if (i2c_start(i2c_adr|I2C_WRITE)) {              // スタートコンディションを発行する
          if (i2c_write(reg_adr)) {               // レジスタアドレスを指定
               if (i2c_rep_start(i2c_adr|I2C_READ)) { // リピート・スタートコンディションを発行する
                     dt = i2c_read(true);
                     id = (int) dt;
                     if (id <= 20)
                      {
                         i2c_stop() ;                                   // ストップコンディションを発行する
                          if (i2c_start(i2c_adr|I2C_WRITE)) {              // スタートコンディションを発行する
                                if (i2c_write(reg_adr - 1)) {               // レジスタアドレスを指定
                                     if (i2c_rep_start(i2c_adr|I2C_READ)) { // リピート・スタートコンディションを発行する
                                      dt = i2c_read(true);
                                         if (dt == 1)
                                          id += 256;
                                     }
                                }
                             }
                       } 
                     if (id != prev_id)
                     {
                                        
                       if (id == 0)
                          *msg = 0x00;
                        else if ((id >= 1) && (id <= 276))
                          strcpy_PF(msg, ninshiki[id-1]);                        
                       else
                           strcpy(msg,"???");
//                      Serial.println(msg);
                        if (display_line2)
                        {
                          lcd.setCursor(0, 1);
                          lcd.print("                ");
                        }
                        memset(buf, 0x20, 16);
                        if (strlen(msg) > 16)
                        {
                          int len;
                          for (len = 15; len >= 0; len--)
                          {
                            if (msg[len] == ' ')
                              break;
                          }
                          lcd.setCursor(0, 1);
                          if (len > 0)
                          {
                            lcd.print(&msg[len+1]);
                            memcpy(buf, msg, len);                        
                          }
                          else
                          {
                            lcd.print(&msg[16]);
                          }
                          display_line2 = true;
                        }
                        else
                        {
                           memcpy(buf, msg, strlen(msg));
                           display_line2 = false;
                       }
                        
                        lcd.setCursor(0, 0);
                        lcd.print(buf);
                        prev_id = id;
                  }
              }
          }
     }
     i2c_stop() ;                                   // ストップコンディションを発行する
     delay(500);
}
